float GetWeight_training_FlatTruthPt_SigToBkg_Pt_sig_top(float pt);
float GetWeight_training_FlatTruthPt_SigToBkg_Pt_sig_W(float pt);
float GetWeight_training_FlatTruthPt_SigToBkg_Pt_bkg_top(float pt);
float GetWeight_training_FlatTruthPt_SigToBkg_Pt_bkg_W(float pt);

void add_top_W_branch_and_trainingweight(TString file_name, TString output_name){

  TFile * f1 = TFile::Open(file_name);
  TTree * t1 =  (TTree*)f1->Get("FlatSubstructureJetTree");

  TFile *output_file = new TFile(output_name,"RECREATE");
  TTree *output_tree = new TTree ("FlatSubstructureJetTree", "FlatSubstructureJetTree");

  int top;
  int W;
  int fjet_fatjet_dRmatched_particle_flavor;
  // for training weights wrt truth jet pt
  float fjet_truthJet_pt;
  float fjet_training_weight_pt_top;
  float fjet_training_weight_pt_W;
  float fjet_m;

  float norm_factor;
  float sum_training_weight_pt_top;
  float sum_training_weight_pt_W;
  int sum_n_events = 0;

  t1->SetBranchStatus("*","1");
  t1->SetBranchAddress("fjet_fatjet_dRmatched_particle_flavor",&fjet_fatjet_dRmatched_particle_flavor);
  t1->SetBranchAddress("fjet_m",&fjet_m);
  t1->SetBranchAddress("fjet_truthJet_pt",&fjet_truthJet_pt);

  output_tree = t1->CloneTree(0);
  output_tree->Branch("top",&top);
  output_tree->Branch("W",&W);
  // for training weights
  output_tree->Branch("fjet_training_weight_pt_top",&fjet_training_weight_pt_top);
  output_tree->Branch("fjet_training_weight_pt_W",&fjet_training_weight_pt_W);

  int n_events = t1->GetEntries();
  //int n_events = 100;

  // Loop to calculate the norm factor for the weights
  for(int i =0; i<n_events; i++){
    fjet_training_weight_pt_top = 0.0;
    fjet_training_weight_pt_W = 0.0;
    top  = -1;
    W  = -1;
    t1->GetEntry(i);
    //cout << fjet_truthJet_pt << endl;
    //cout << "fjet_m:" << fjet_m << endl;
    if (file_name.Contains("zprime")){
      if(std::abs(fjet_fatjet_dRmatched_particle_flavor)!= 6) continue;
      top = 1;
      W = 0;
      // training weight for tops
      if (fjet_m > 40000) {
        fjet_training_weight_pt_top = GetWeight_training_FlatTruthPt_SigToBkg_Pt_sig_top(fjet_truthJet_pt/1000.);
        //cout << "fjet_training_weight_pt_top: " << fjet_training_weight_pt_top << endl;
        sum_training_weight_pt_top += fjet_training_weight_pt_top;
        sum_n_events++;
        //cout << "sum_n_events: " << sum_n_events << endl;
      }
    }
    if (file_name.Contains("Wprime")){
      if(std::abs(fjet_fatjet_dRmatched_particle_flavor)!= 24) continue;
      top = 0;
      W = 1;
      // training weight for Ws
      if (fjet_m > 40000) {
        fjet_training_weight_pt_W = GetWeight_training_FlatTruthPt_SigToBkg_Pt_sig_W(fjet_truthJet_pt/1000.);
        sum_training_weight_pt_W +=  fjet_training_weight_pt_W;
        sum_n_events++;
      }
    }
    if(file_name.Contains("jetjet")){
      top = 0;
      W = 0;
      // training weight for background
      if (fjet_m > 40000) {
        fjet_training_weight_pt_top = GetWeight_training_FlatTruthPt_SigToBkg_Pt_bkg_top(fjet_truthJet_pt/1000.);
        sum_training_weight_pt_top += fjet_training_weight_pt_top;

        fjet_training_weight_pt_W = GetWeight_training_FlatTruthPt_SigToBkg_Pt_bkg_W(fjet_truthJet_pt/1000.);
        sum_training_weight_pt_W += fjet_training_weight_pt_W;

        sum_n_events++;
      }
    }
   output_tree->Fill();
  }

  cout << "n_events: " << n_events << endl;
  cout << "sum_n_events: " << sum_n_events << endl;
  cout << "sum_training_weight_pt_top: " << sum_training_weight_pt_top << endl;
  cout << "sum_training_weight_pt_W: " << sum_training_weight_pt_W << endl;

  output_tree->Write();
  output_file->Close();
}

float GetWeight_training_FlatTruthPt_SigToBkg_Pt_sig_top(float pt){
  float scale=0;
  if(pt<0)  scale=0;
  else if(pt<210.0)  scale=0.584947587507;
  else if(pt<220.0)  scale=0.595126533095;
  else if(pt<230.0)  scale=0.595066149969;
  else if(pt<240.0)  scale=0.585064293075;
  else if(pt<250.0)  scale=0.565517966853;
  else if(pt<260.0)  scale=0.540827091923;
  else if(pt<270.0)  scale=0.517653172559;
  else if(pt<280.0)  scale=0.499469413614;
  else if(pt<290.0)  scale=0.472167869601;
  else if(pt<300.0)  scale=0.44850081233;
  else if(pt<310.0)  scale=0.436274149035;
  else if(pt<320.0)  scale=0.423103301918;
  else if(pt<330.0)  scale=0.419262279102;
  else if(pt<340.0)  scale=0.426875531136;
  else if(pt<350.0)  scale=0.438000863257;
  else if(pt<360.0)  scale=0.449342644891;
  else if(pt<370.0)  scale=0.450118541481;
  else if(pt<380.0)  scale=0.446129880962;
  else if(pt<390.0)  scale=0.436339065462;
  else if(pt<400.0)  scale=0.428059393481;
  else if(pt<410.0)  scale=0.420902016491;
  else if(pt<420.0)  scale=0.405102023708;
  else if(pt<430.0)  scale=0.398036667658;
  else if(pt<440.0)  scale=0.392680311578;
  else if(pt<450.0)  scale=0.387223171686;
  else if(pt<460.0)  scale=0.388364148957;
  else if(pt<470.0)  scale=0.393523387305;
  else if(pt<480.0)  scale=0.399664025811;
  else if(pt<490.0)  scale=0.418977740377;
  else if(pt<500.0)  scale=0.423362910582;
  else if(pt<510.0)  scale=0.432207347369;
  else if(pt<520.0)  scale=0.427887627369;
  else if(pt<530.0)  scale=0.426224092364;
  else if(pt<540.0)  scale=0.42249375035;
  else if(pt<550.0)  scale=0.417263853606;
  else if(pt<560.0)  scale=0.412205340471;
  else if(pt<570.0)  scale=0.408146516741;
  else if(pt<580.0)  scale=0.409028860001;
  else if(pt<590.0)  scale=0.409414331076;
  else if(pt<600.0)  scale=0.414653199921;
  else if(pt<610.0)  scale=0.429942044652;
  else if(pt<620.0)  scale=0.433741509655;
  else if(pt<630.0)  scale=0.442227961393;
  else if(pt<640.0)  scale=0.447201354298;
  else if(pt<650.0)  scale=0.449894105958;
  else if(pt<660.0)  scale=0.450741181985;
  else if(pt<670.0)  scale=0.446894712577;
  else if(pt<680.0)  scale=0.451852352472;
  else if(pt<690.0)  scale=0.448175261866;
  else if(pt<700.0)  scale=0.445756937035;
  else if(pt<710.0)  scale=0.450654595106;
  else if(pt<720.0)  scale=0.449136179168;
  else if(pt<730.0)  scale=0.454901292764;
  else if(pt<740.0)  scale=0.469184045219;
  else if(pt<750.0)  scale=0.481569014431;
  else if(pt<760.0)  scale=0.490038375671;
  else if(pt<770.0)  scale=0.493688797123;
  else if(pt<780.0)  scale=0.501884167674;
  else if(pt<790.0)  scale=0.497457242825;
  else if(pt<800.0)  scale=0.507837525791;
  else if(pt<810.0)  scale=0.504734705658;
  else if(pt<820.0)  scale=0.499002006512;
  else if(pt<830.0)  scale=0.498704986934;
  else if(pt<840.0)  scale=0.512340125701;
  else if(pt<850.0)  scale=0.514204115825;
  else if(pt<860.0)  scale=0.52321762142;
  else if(pt<870.0)  scale=0.537334002563;
  else if(pt<880.0)  scale=0.546496138079;
  else if(pt<890.0)  scale=0.556767713331;
  else if(pt<900.0)  scale=0.560652811926;
  else if(pt<910.0)  scale=0.567817358341;
  else if(pt<920.0)  scale=0.577546116178;
  else if(pt<930.0)  scale=0.572948100285;
  else if(pt<940.0)  scale=0.57166369807;
  else if(pt<950.0)  scale=0.569222598706;
  else if(pt<960.0)  scale=0.575534262004;
  else if(pt<970.0)  scale=0.582276332773;
  else if(pt<980.0)  scale=0.587672906076;
  else if(pt<990.0)  scale=0.602400186515;
  else if(pt<1000.0)  scale=0.623334897047;
  else if(pt<1010.0)  scale=0.628444163029;
  else if(pt<1020.0)  scale=0.649207999359;
  else if(pt<1030.0)  scale=0.658538091404;
  else if(pt<1040.0)  scale=0.654532931086;
  else if(pt<1050.0)  scale=0.661024427413;
  else if(pt<1060.0)  scale=0.670354806783;
  else if(pt<1070.0)  scale=0.677243759325;
  else if(pt<1080.0)  scale=0.695802762654;
  else if(pt<1090.0)  scale=0.712107037941;
  else if(pt<1100.0)  scale=0.730328670401;
  else if(pt<1110.0)  scale=0.758472701885;
  else if(pt<1120.0)  scale=0.797399152672;
  else if(pt<1130.0)  scale=0.833371602618;
  else if(pt<1140.0)  scale=0.870540898684;
  else if(pt<1150.0)  scale=0.904506100486;
  else if(pt<1160.0)  scale=0.932994488009;
  else if(pt<1170.0)  scale=0.960338808859;
  else if(pt<1180.0)  scale=0.972197884117;
  else if(pt<1190.0)  scale=0.962940359679;
  else if(pt<1200.0)  scale=1.00544601841;
  else if(pt<1210.0)  scale=1.0151037182;
  else if(pt<1220.0)  scale=1.05651973874;
  else if(pt<1230.0)  scale=1.08235271917;
  else if(pt<1240.0)  scale=1.11581272258;
  else if(pt<1250.0)  scale=1.1778832302;
  else if(pt<1260.0)  scale=1.20251551587;
  else if(pt<1270.0)  scale=1.26693373322;
  else if(pt<1280.0)  scale=1.3084817447;
  else if(pt<1290.0)  scale=1.33986740303;
  else if(pt<1300.0)  scale=1.36417476;
  else if(pt<1310.0)  scale=1.3614831623;
  else if(pt<1320.0)  scale=1.42326361478;
  else if(pt<1330.0)  scale=1.44269332627;
  else if(pt<1340.0)  scale=1.49376531728;
  else if(pt<1350.0)  scale=1.521865521;
  else if(pt<1360.0)  scale=1.58221455582;
  else if(pt<1370.0)  scale=1.67006537448;
  else if(pt<1380.0)  scale=1.75030430607;
  else if(pt<1390.0)  scale=1.83432979955;
  else if(pt<1400.0)  scale=1.91206823857;
  else if(pt<1410.0)  scale=1.95933514959;
  else if(pt<1420.0)  scale=2.02705004719;
  else if(pt<1430.0)  scale=2.05222871346;
  else if(pt<1440.0)  scale=2.1824259904;
  else if(pt<1450.0)  scale=2.25413898351;
  else if(pt<1460.0)  scale=2.29785295064;
  else if(pt<1470.0)  scale=2.39008542058;
  else if(pt<1480.0)  scale=2.56125306972;
  else if(pt<1490.0)  scale=2.73502890199;
  else if(pt<1500.0)  scale=2.86810250469;
  else if(pt<1510.0)  scale=3.15761480857;
  else if(pt<1520.0)  scale=3.41103189405;
  else if(pt<1530.0)  scale=3.61161926215;
  else if(pt<1540.0)  scale=3.67153041666;
  else if(pt<1550.0)  scale=3.92982891275;
  else if(pt<1560.0)  scale=3.94834711463;
  else if(pt<1570.0)  scale=4.01868426012;
  else if(pt<1580.0)  scale=4.24097568896;
  else if(pt<1590.0)  scale=4.44002242916;
  else if(pt<1600.0)  scale=4.41329522142;
  else if(pt<1610.0)  scale=4.36079515598;
  else if(pt<1620.0)  scale=4.42828938379;
  else if(pt<1630.0)  scale=4.46707506566;
  else if(pt<1640.0)  scale=4.63657668066;
  else if(pt<1650.0)  scale=4.67538419752;
  else if(pt<1660.0)  scale=4.38360946856;
  else if(pt<1670.0)  scale=4.51001109697;
  else if(pt<1680.0)  scale=4.57866482548;
  else if(pt<1690.0)  scale=4.5414399263;
  else if(pt<1700.0)  scale=4.72243938007;
  else if(pt<1710.0)  scale=4.70539061651;
  else if(pt<1720.0)  scale=4.79188680861;
  else if(pt<1730.0)  scale=4.67166031909;
  else if(pt<1740.0)  scale=4.49790601219;
  else if(pt<1750.0)  scale=4.75305481242;
  else if(pt<1760.0)  scale=4.63291434075;
  else if(pt<1770.0)  scale=4.75883954709;
  else if(pt<1780.0)  scale=4.62925778189;
  else if(pt<1790.0)  scale=4.52392562617;
  else if(pt<1800.0)  scale=4.77433416241;
  else if(pt<1810.0)  scale=4.52567108449;
  else if(pt<1820.0)  scale=4.66237637858;
  else if(pt<1830.0)  scale=4.5431986521;
  else if(pt<1840.0)  scale=4.56086279183;
  else if(pt<1850.0)  scale=4.70350410247;
  else if(pt<1860.0)  scale=4.52567108449;
  else if(pt<1870.0)  scale=4.73769748658;
  else if(pt<1880.0)  scale=4.72243938007;
  else if(pt<1890.0)  scale=4.8016942295;
  else if(pt<1900.0)  scale=4.87351027854;
  else if(pt<1910.0)  scale=4.77433416241;
  else if(pt<1920.0)  scale=4.89180112967;
  else if(pt<1930.0)  scale=5.04105684032;
  else if(pt<1940.0)  scale=4.96425688581;
  else if(pt<1950.0)  scale=5.17219548036;
  else if(pt<1960.0)  scale=5.32964058938;
  else if(pt<1970.0)  scale=5.75026439167;
  else if(pt<1980.0)  scale=6.01566086776;
  else if(pt<1990.0)  scale=6.20663449048;
  else if(pt<2000.0)  scale=7.06233573043;
  else if(pt<2010.0)  scale=7.52439958831;
  else if(pt<2020.0)  scale=7.91000630922;
  else if(pt<2030.0)  scale=8.88004485832;
  else if(pt<2040.0)  scale=9.20042302668;
  else if(pt<2050.0)  scale=9.79994893834;
  else if(pt<2060.0)  scale=10.1475248916;
  else if(pt<2070.0)  scale=10.0261015809;
  else if(pt<2080.0)  scale=11.1189948316;
  else if(pt<2090.0)  scale=11.1719418044;
  else if(pt<2100.0)  scale=11.4892649299;
  else if(pt<2110.0)  scale=11.7776494236;
  else if(pt<2120.0)  scale=12.0684559816;
  else if(pt<2130.0)  scale=12.0933391039;
  else if(pt<2140.0)  scale=13.1361023918;
  else if(pt<2150.0)  scale=13.0050318873;
  else if(pt<2160.0)  scale=12.5594641764;
  else if(pt<2170.0)  scale=12.9190954393;
  else if(pt<2180.0)  scale=12.2961630168;
  else if(pt<2190.0)  scale=13.9982568322;
  else if(pt<2200.0)  scale=13.0194668498;
  else if(pt<2210.0)  scale=13.5927450015;
  else if(pt<2220.0)  scale=14.1161722942;
  else if(pt<2230.0)  scale=13.800634115;
  else if(pt<2240.0)  scale=13.2698405895;
  else if(pt<2250.0)  scale=13.0921192714;
  else if(pt<2260.0)  scale=14.2016216218;
  else if(pt<2270.0)  scale=14.6448672016;
  else if(pt<2280.0)  scale=13.254846595;
  else if(pt<2290.0)  scale=14.4287079118;
  else if(pt<2300.0)  scale=13.7199283337;
  else if(pt<2310.0)  scale=14.4109810431;
  else if(pt<2320.0)  scale=15.2147071758;
  else if(pt<2330.0)  scale=14.7926097849;
  else if(pt<2340.0)  scale=14.0317450917;
  else if(pt<2350.0)  scale=14.0485493793;
  else if(pt<2360.0)  scale=14.3405125235;
  else if(pt<2370.0)  scale=15.4349206157;
  else if(pt<2380.0)  scale=14.6631745092;
  else if(pt<2390.0)  scale=15.414636843;
  else if(pt<2400.0)  scale=14.5000480278;
  else if(pt<2410.0)  scale=15.2940543897;
  else if(pt<2420.0)  scale=15.1753422872;
  else if(pt<2430.0)  scale=16.2248119354;
  else if(pt<2440.0)  scale=17.3528683447;
  else if(pt<2450.0)  scale=16.8784730752;
  else if(pt<2460.0)  scale=18.1306634296;
  else if(pt<2470.0)  scale=20.5798934455;
  else if(pt<2480.0)  scale=21.2509763706;
  else if(pt<2490.0)  scale=23.9398763181;
  else if(pt<2500.0)  scale=28.198411879;

  return scale;
}

float GetWeight_training_FlatTruthPt_SigToBkg_Pt_sig_W(float pt){
  float scale=0;
  if(pt<0)  scale=0;
  else if(pt<210.0)  scale=0.766260664124;
  else if(pt<220.0)  scale=0.717630297274;
  else if(pt<230.0)  scale=0.671955494085;
  else if(pt<240.0)  scale=0.598146257241;
  else if(pt<250.0)  scale=0.560934397451;
  else if(pt<260.0)  scale=0.489308831191;
  else if(pt<270.0)  scale=0.437851660869;
  else if(pt<280.0)  scale=0.382740586835;
  else if(pt<290.0)  scale=0.34609249572;
  else if(pt<300.0)  scale=0.380348682878;
  else if(pt<310.0)  scale=0.466633679525;
  else if(pt<320.0)  scale=0.575761543004;
  else if(pt<330.0)  scale=0.646955435267;
  else if(pt<340.0)  scale=0.676790506962;
  else if(pt<350.0)  scale=0.687014279365;
  else if(pt<360.0)  scale=0.657229445514;
  else if(pt<370.0)  scale=0.625918605723;
  else if(pt<380.0)  scale=0.596508216804;
  else if(pt<390.0)  scale=0.549028126914;
  else if(pt<400.0)  scale=0.575681456016;
  else if(pt<410.0)  scale=0.634167019928;
  else if(pt<420.0)  scale=0.726447916779;
  else if(pt<430.0)  scale=0.800652726153;
  else if(pt<440.0)  scale=0.836751695443;
  else if(pt<450.0)  scale=0.831874136094;
  else if(pt<460.0)  scale=0.821471581511;
  else if(pt<470.0)  scale=0.805954018545;
  else if(pt<480.0)  scale=0.809897071123;
  else if(pt<490.0)  scale=0.764279558515;
  else if(pt<500.0)  scale=0.727725320817;
  else if(pt<510.0)  scale=0.679234175427;
  else if(pt<520.0)  scale=0.65796088718;
  else if(pt<530.0)  scale=0.621127703287;
  else if(pt<540.0)  scale=0.58954042724;
  else if(pt<550.0)  scale=0.566462338079;
  else if(pt<560.0)  scale=0.569816041576;
  else if(pt<570.0)  scale=0.568876130567;
  else if(pt<580.0)  scale=0.561848193705;
  else if(pt<590.0)  scale=0.555961046528;
  else if(pt<600.0)  scale=0.547213264589;
  else if(pt<610.0)  scale=0.550708470108;
  else if(pt<620.0)  scale=0.573368515725;
  else if(pt<630.0)  scale=0.55987201794;
  else if(pt<640.0)  scale=0.552104303409;
  else if(pt<650.0)  scale=0.551883438452;
  else if(pt<660.0)  scale=0.560858381916;
  else if(pt<670.0)  scale=0.570208573954;
  else if(pt<680.0)  scale=0.563915229044;
  else if(pt<690.0)  scale=0.559040102898;
  else if(pt<700.0)  scale=0.555811719258;
  else if(pt<710.0)  scale=0.565456182306;
  else if(pt<720.0)  scale=0.575361295284;
  else if(pt<730.0)  scale=0.573447960423;
  else if(pt<740.0)  scale=0.564684671486;
  else if(pt<750.0)  scale=0.562382651616;
  else if(pt<760.0)  scale=0.570287145336;
  else if(pt<770.0)  scale=0.575761543004;
  else if(pt<780.0)  scale=0.56708330579;
  else if(pt<790.0)  scale=0.55919117015;
  else if(pt<800.0)  scale=0.583472996504;
  else if(pt<810.0)  scale=0.581750603321;
  else if(pt<820.0)  scale=0.584709519177;
  else if(pt<830.0)  scale=0.602061971559;
  else if(pt<840.0)  scale=0.599532659686;
  else if(pt<850.0)  scale=0.580689491318;
  else if(pt<860.0)  scale=0.589624416957;
  else if(pt<870.0)  scale=0.588367078645;
  else if(pt<880.0)  scale=0.58620027477;
  else if(pt<890.0)  scale=0.593599223492;
  else if(pt<900.0)  scale=0.575281319596;
  else if(pt<910.0)  scale=0.593428996216;
  else if(pt<920.0)  scale=0.596250366544;
  else if(pt<930.0)  scale=0.609959295225;
  else if(pt<940.0)  scale=0.599359012821;
  else if(pt<950.0)  scale=0.58166884166;
  else if(pt<960.0)  scale=0.601711804806;
  else if(pt<970.0)  scale=0.601187375804;
  else if(pt<980.0)  scale=0.597024510602;
  else if(pt<990.0)  scale=0.587031778009;
  else if(pt<1000.0)  scale=0.600838264033;
  else if(pt<1010.0)  scale=0.601886856652;
  else if(pt<1020.0)  scale=0.624407638136;
  else if(pt<1030.0)  scale=0.64604648714;
  else if(pt<1040.0)  scale=0.660164919952;
  else if(pt<1050.0)  scale=0.666974031346;
  else if(pt<1060.0)  scale=0.671955494085;
  else if(pt<1070.0)  scale=0.675464971216;
  else if(pt<1080.0)  scale=0.68587568904;
  else if(pt<1090.0)  scale=0.697551623233;
  else if(pt<1100.0)  scale=0.712441697151;
  else if(pt<1110.0)  scale=0.711829019429;
  else if(pt<1120.0)  scale=0.725938232533;
  else if(pt<1130.0)  scale=0.738371780968;
  else if(pt<1140.0)  scale=0.753975959854;
  else if(pt<1150.0)  scale=0.750829801038;
  else if(pt<1160.0)  scale=0.75992908539;
  else if(pt<1170.0)  scale=0.770540658967;
  else if(pt<1180.0)  scale=0.778659272392;
  else if(pt<1190.0)  scale=0.776905190616;
  else if(pt<1200.0)  scale=0.78456376233;
  else if(pt<1210.0)  scale=0.792526631376;
  else if(pt<1220.0)  scale=0.818385189377;
  else if(pt<1230.0)  scale=0.823596794283;
  else if(pt<1240.0)  scale=0.82392471529;
  else if(pt<1250.0)  scale=0.833046302765;
  else if(pt<1260.0)  scale=0.835569160156;
  else if(pt<1270.0)  scale=0.861664346388;
  else if(pt<1280.0)  scale=0.883366927242;
  else if(pt<1290.0)  scale=0.888487285073;
  else if(pt<1300.0)  scale=0.912384010998;
  else if(pt<1310.0)  scale=0.941226733394;
  else if(pt<1320.0)  scale=0.937389355785;
  else if(pt<1330.0)  scale=0.931901342215;
  else if(pt<1340.0)  scale=0.985844237665;
  else if(pt<1350.0)  scale=0.962011607346;
  else if(pt<1360.0)  scale=0.978386317187;
  else if(pt<1370.0)  scale=1.00402080222;
  else if(pt<1380.0)  scale=1.04010397225;
  else if(pt<1390.0)  scale=1.02187010829;
  else if(pt<1400.0)  scale=1.08000365821;
  else if(pt<1410.0)  scale=1.09370348758;
  else if(pt<1420.0)  scale=1.14546742915;
  else if(pt<1430.0)  scale=1.20482501448;
  else if(pt<1440.0)  scale=1.19473840654;
  else if(pt<1450.0)  scale=1.19508339781;
  else if(pt<1460.0)  scale=1.28407507002;
  else if(pt<1470.0)  scale=1.24543300184;
  else if(pt<1480.0)  scale=1.32011926691;
  else if(pt<1490.0)  scale=1.31425018638;
  else if(pt<1500.0)  scale=1.40148116118;
  else if(pt<1510.0)  scale=1.48123615109;
  else if(pt<1520.0)  scale=1.51651669303;
  else if(pt<1530.0)  scale=1.52097539524;
  else if(pt<1540.0)  scale=1.63064380502;
  else if(pt<1550.0)  scale=1.62807781252;
  else if(pt<1560.0)  scale=1.68234716095;
  else if(pt<1570.0)  scale=1.68098039719;
  else if(pt<1580.0)  scale=1.72010559999;
  else if(pt<1590.0)  scale=1.73379720008;
  else if(pt<1600.0)  scale=1.66877977602;
  else if(pt<1610.0)  scale=1.67485786783;
  else if(pt<1620.0)  scale=1.73162094675;
  else if(pt<1630.0)  scale=1.8966883168;
  else if(pt<1640.0)  scale=1.86170669895;
  else if(pt<1650.0)  scale=1.96233939832;
  else if(pt<1660.0)  scale=1.87775581717;
  else if(pt<1670.0)  scale=1.96327027313;
  else if(pt<1680.0)  scale=1.84922875422;
  else if(pt<1690.0)  scale=1.97074939443;
  else if(pt<1700.0)  scale=1.98874290525;
  else if(pt<1710.0)  scale=1.98969900475;
  else if(pt<1720.0)  scale=2.03971104782;
  else if(pt<1730.0)  scale=2.1190854449;
  else if(pt<1740.0)  scale=2.16113522586;
  else if(pt<1750.0)  scale=2.1190854449;
  else if(pt<1760.0)  scale=2.10293385645;
  else if(pt<1770.0)  scale=2.17705106015;
  else if(pt<1780.0)  scale=2.22264988873;
  else if(pt<1790.0)  scale=2.2048876103;
  else if(pt<1800.0)  scale=2.35681883007;
  else if(pt<1810.0)  scale=2.34480109908;
  else if(pt<1820.0)  scale=2.26399011904;
  else if(pt<1830.0)  scale=2.30818403082;
  else if(pt<1840.0)  scale=2.37712459259;
  else if(pt<1850.0)  scale=2.56735358982;
  else if(pt<1860.0)  scale=2.45176172509;
  else if(pt<1870.0)  scale=2.59309145969;
  else if(pt<1880.0)  scale=2.47226637576;
  else if(pt<1890.0)  scale=2.58176787628;
  else if(pt<1900.0)  scale=2.5281452674;
  else if(pt<1910.0)  scale=2.74623343847;
  else if(pt<1920.0)  scale=2.75354210693;
  else if(pt<1930.0)  scale=2.710264451;
  else if(pt<1940.0)  scale=2.85813107283;
  else if(pt<1950.0)  scale=2.74623343847;
  else if(pt<1960.0)  scale=2.78879638784;
  else if(pt<1970.0)  scale=2.8230381809;
  else if(pt<1980.0)  scale=2.87400957145;
  else if(pt<1990.0)  scale=2.74805711746;
  else if(pt<2000.0)  scale=2.92478727365;
  else if(pt<2010.0)  scale=2.89816090115;
  else if(pt<2020.0)  scale=2.93932817129;
  else if(pt<2030.0)  scale=3.04530825761;
  else if(pt<2040.0)  scale=3.20571171865;
  else if(pt<2050.0)  scale=3.111709622;
  else if(pt<2060.0)  scale=3.40903953362;
  else if(pt<2070.0)  scale=3.21317850423;
  else if(pt<2080.0)  scale=3.23073691899;
  else if(pt<2090.0)  scale=3.2924216076;
  else if(pt<2100.0)  scale=3.27418819592;
  else if(pt<2110.0)  scale=3.23326086119;
  else if(pt<2120.0)  scale=3.4777932433;
  else if(pt<2130.0)  scale=3.60189190414;
  else if(pt<2140.0)  scale=3.58318095779;
  else if(pt<2150.0)  scale=3.73180678943;
  else if(pt<2160.0)  scale=3.9340056559;
  else if(pt<2170.0)  scale=3.97557544833;
  else if(pt<2180.0)  scale=3.86421463482;
  else if(pt<2190.0)  scale=3.94902093831;
  else if(pt<2200.0)  scale=3.7385491717;
  else if(pt<2210.0)  scale=3.91539646804;
  else if(pt<2220.0)  scale=4.28867762861;
  else if(pt<2230.0)  scale=4.35181296161;
  else if(pt<2240.0)  scale=4.27980731971;
  else if(pt<2250.0)  scale=4.51316665029;
  else if(pt<2260.0)  scale=4.48382863544;
  else if(pt<2270.0)  scale=4.69758683537;
  else if(pt<2280.0)  scale=4.8517865726;
  else if(pt<2290.0)  scale=4.76245567157;
  else if(pt<2300.0)  scale=4.78447857881;
  else if(pt<2310.0)  scale=4.61894408741;
  else if(pt<2320.0)  scale=5.05938143255;
  else if(pt<2330.0)  scale=4.89193120147;
  else if(pt<2340.0)  scale=5.13470717963;
  else if(pt<2350.0)  scale=4.69226062799;
  else if(pt<2360.0)  scale=5.38176079811;
  else if(pt<2370.0)  scale=5.25199739567;
  else if(pt<2380.0)  scale=4.8235126142;
  else if(pt<2390.0)  scale=5.09049675333;
  else if(pt<2400.0)  scale=5.05320375322;
  else if(pt<2410.0)  scale=5.42408131173;
  else if(pt<2420.0)  scale=5.57008613238;
  else if(pt<2430.0)  scale=5.38876810198;
  else if(pt<2440.0)  scale=5.63838395006;
  else if(pt<2450.0)  scale=6.11310757885;
  else if(pt<2460.0)  scale=5.85371132946;
  else if(pt<2470.0)  scale=6.03290673826;
  else if(pt<2480.0)  scale=6.13122048201;
  else if(pt<2490.0)  scale=6.68590311271;
  else if(pt<2500.0)  scale=7.17257175984;


  return scale;
}



float GetWeight_training_FlatTruthPt_SigToBkg_Pt_bkg_W(float pt){
  float scale=0;
  if(pt<0)  scale=0;

  else if(pt<210.0)  scale=0.890405147046;
  else if(pt<220.0)  scale=0.837758868925;
  else if(pt<230.0)  scale=0.796331204676;
  else if(pt<240.0)  scale=0.75602635591;
  else if(pt<250.0)  scale=0.728753054122;
  else if(pt<260.0)  scale=0.705331054225;
  else if(pt<270.0)  scale=0.670896648248;
  else if(pt<280.0)  scale=0.655062033535;
  else if(pt<290.0)  scale=0.631244222583;
  else if(pt<300.0)  scale=0.611464609379;
  else if(pt<310.0)  scale=0.593127753808;
  else if(pt<320.0)  scale=0.576743422567;
  else if(pt<330.0)  scale=0.559538143512;
  else if(pt<340.0)  scale=0.542988403975;
  else if(pt<350.0)  scale=0.531369476429;
  else if(pt<360.0)  scale=0.520560956395;
  else if(pt<370.0)  scale=0.510282475235;
  else if(pt<380.0)  scale=0.506611061179;
  else if(pt<390.0)  scale=0.504597335685;
  else if(pt<400.0)  scale=0.505593404889;
  else if(pt<410.0)  scale=0.58017383221;
  else if(pt<420.0)  scale=0.755031483031;
  else if(pt<430.0)  scale=0.82799189912;
  else if(pt<440.0)  scale=0.848087277316;
  else if(pt<450.0)  scale=0.846720906871;
  else if(pt<460.0)  scale=0.838293357262;
  else if(pt<470.0)  scale=0.828994937723;
  else if(pt<480.0)  scale=0.813801502521;
  else if(pt<490.0)  scale=0.794482091734;
  else if(pt<500.0)  scale=0.776356807731;
  else if(pt<510.0)  scale=0.757390461848;
  else if(pt<520.0)  scale=0.738750935108;
  else if(pt<530.0)  scale=0.716036227728;
  else if(pt<540.0)  scale=0.69902301976;
  else if(pt<550.0)  scale=0.683030291239;
  else if(pt<560.0)  scale=0.666844653078;
  else if(pt<570.0)  scale=0.651017835408;
  else if(pt<580.0)  scale=0.63200940682;
  else if(pt<590.0)  scale=0.615875686839;
  else if(pt<600.0)  scale=0.602044890267;
  else if(pt<610.0)  scale=0.586836046046;
  else if(pt<620.0)  scale=0.573851615903;
  else if(pt<630.0)  scale=0.559114320556;
  else if(pt<640.0)  scale=0.547561712205;
  else if(pt<650.0)  scale=0.53481283189;
  else if(pt<660.0)  scale=0.522831294493;
  else if(pt<670.0)  scale=0.511729330178;
  else if(pt<680.0)  scale=0.499346591116;
  else if(pt<690.0)  scale=0.490285147401;
  else if(pt<700.0)  scale=0.482638171079;
  else if(pt<710.0)  scale=0.473812200912;
  else if(pt<720.0)  scale=0.466300657997;
  else if(pt<730.0)  scale=0.458754322332;
  else if(pt<740.0)  scale=0.45656239486;
  else if(pt<750.0)  scale=0.448175993297;
  else if(pt<760.0)  scale=0.444533787319;
  else if(pt<770.0)  scale=0.441543017471;
  else if(pt<780.0)  scale=0.443006448705;
  else if(pt<790.0)  scale=0.442138835386;
  else if(pt<800.0)  scale=0.452611583241;
  else if(pt<810.0)  scale=0.542725931614;
  else if(pt<820.0)  scale=0.746643336495;
  else if(pt<830.0)  scale=0.834958536479;
  else if(pt<840.0)  scale=0.871355434516;
  else if(pt<850.0)  scale=0.884209253816;
  else if(pt<860.0)  scale=0.884346098315;
  else if(pt<870.0)  scale=0.884250872171;
  else if(pt<880.0)  scale=0.874883100061;
  else if(pt<890.0)  scale=0.8630107258;
  else if(pt<900.0)  scale=0.853724598806;
  else if(pt<910.0)  scale=0.845146896976;
  else if(pt<920.0)  scale=0.826887211545;
  else if(pt<930.0)  scale=0.809310121276;
  else if(pt<940.0)  scale=0.795617482504;
  else if(pt<950.0)  scale=0.781412631446;
  else if(pt<960.0)  scale=0.767266832176;
  else if(pt<970.0)  scale=0.75225622644;
  else if(pt<980.0)  scale=0.735179492932;
  else if(pt<990.0)  scale=0.721208647294;
  else if(pt<1000.0)  scale=0.709425084801;
  else if(pt<1010.0)  scale=0.692297543013;
  else if(pt<1020.0)  scale=0.680426860764;
  else if(pt<1030.0)  scale=0.668279381434;
  else if(pt<1040.0)  scale=0.652433748623;
  else if(pt<1050.0)  scale=0.642131364901;
  else if(pt<1060.0)  scale=0.629381596587;
  else if(pt<1070.0)  scale=0.614576430141;
  else if(pt<1080.0)  scale=0.60250315975;
  else if(pt<1090.0)  scale=0.590019444661;
  else if(pt<1100.0)  scale=0.579892160353;
  else if(pt<1110.0)  scale=0.570163586263;
  else if(pt<1120.0)  scale=0.559578652905;
  else if(pt<1130.0)  scale=0.553023859632;
  else if(pt<1140.0)  scale=0.538193063991;
  else if(pt<1150.0)  scale=0.528611643169;
  else if(pt<1160.0)  scale=0.517975210007;
  else if(pt<1170.0)  scale=0.512166218495;
  else if(pt<1180.0)  scale=0.502090577998;
  else if(pt<1190.0)  scale=0.496639935941;
  else if(pt<1200.0)  scale=0.492047795891;
  else if(pt<1210.0)  scale=0.483654405654;
  else if(pt<1220.0)  scale=0.479436429404;
  else if(pt<1230.0)  scale=0.472350699585;
  else if(pt<1240.0)  scale=0.470181999281;
  else if(pt<1250.0)  scale=0.467631669509;
  else if(pt<1260.0)  scale=0.466721383564;
  else if(pt<1270.0)  scale=0.465971553182;
  else if(pt<1280.0)  scale=0.471794385173;
  else if(pt<1290.0)  scale=0.481910579075;
  else if(pt<1300.0)  scale=0.501427581148;
  else if(pt<1310.0)  scale=0.697779381684;
  else if(pt<1320.0)  scale=1.3477184243;
  else if(pt<1330.0)  scale=1.84979478578;
  else if(pt<1340.0)  scale=2.17376818995;
  else if(pt<1350.0)  scale=2.41218062205;
  else if(pt<1360.0)  scale=2.58025317331;
  else if(pt<1370.0)  scale=2.69433137439;
  else if(pt<1380.0)  scale=2.78928084652;
  else if(pt<1390.0)  scale=2.85609792223;
  else if(pt<1400.0)  scale=2.88665673192;
  else if(pt<1410.0)  scale=2.93259546712;
  else if(pt<1420.0)  scale=2.90587351128;
  else if(pt<1430.0)  scale=2.90638774281;
  else if(pt<1440.0)  scale=2.88039168689;
  else if(pt<1450.0)  scale=2.87019844747;
  else if(pt<1460.0)  scale=2.83771564767;
  else if(pt<1470.0)  scale=2.78951772184;
  else if(pt<1480.0)  scale=2.74861025639;
  else if(pt<1490.0)  scale=2.69245405076;
  else if(pt<1500.0)  scale=2.68020615367;
  else if(pt<1510.0)  scale=2.60346503953;
  else if(pt<1520.0)  scale=2.57565025514;
  else if(pt<1530.0)  scale=2.52152427732;
  else if(pt<1540.0)  scale=2.47027662797;
  else if(pt<1550.0)  scale=2.41875283773;
  else if(pt<1560.0)  scale=2.37211485351;
  else if(pt<1570.0)  scale=2.32736508444;
  else if(pt<1580.0)  scale=2.31155997827;
  else if(pt<1590.0)  scale=2.21873534955;
  else if(pt<1600.0)  scale=2.18945282027;
  else if(pt<1610.0)  scale=2.14944412374;
  else if(pt<1620.0)  scale=2.09348262992;
  else if(pt<1630.0)  scale=2.07398567119;
  else if(pt<1640.0)  scale=2.02202346158;
  else if(pt<1650.0)  scale=1.97443948684;
  else if(pt<1660.0)  scale=1.93108472908;
  else if(pt<1670.0)  scale=1.90626138623;
  else if(pt<1680.0)  scale=1.8796451532;
  else if(pt<1690.0)  scale=1.83820061362;
  else if(pt<1700.0)  scale=1.80620909184;
  else if(pt<1710.0)  scale=1.77749756533;
  else if(pt<1720.0)  scale=1.74536148205;
  else if(pt<1730.0)  scale=1.72734885902;
  else if(pt<1740.0)  scale=1.70803735485;
  else if(pt<1750.0)  scale=1.69729196645;
  else if(pt<1760.0)  scale=1.6820599941;
  else if(pt<1770.0)  scale=1.68683253173;
  else if(pt<1780.0)  scale=1.68648610358;
  else if(pt<1790.0)  scale=1.71389708692;
  else if(pt<1800.0)  scale=1.7742332126;
  else if(pt<1810.0)  scale=2.48227064914;
  else if(pt<1820.0)  scale=4.47190607449;
  else if(pt<1830.0)  scale=5.78602546535;
  else if(pt<1840.0)  scale=6.50988774181;
  else if(pt<1850.0)  scale=7.0510397106;
  else if(pt<1860.0)  scale=7.29898721193;
  else if(pt<1870.0)  scale=7.39928322365;
  else if(pt<1880.0)  scale=7.48314562546;
  else if(pt<1890.0)  scale=7.61013992155;
  else if(pt<1900.0)  scale=7.56587948743;
  else if(pt<1910.0)  scale=7.5580455539;
  else if(pt<1920.0)  scale=7.43150880689;
  else if(pt<1930.0)  scale=7.34879266331;
  else if(pt<1940.0)  scale=7.13528107251;
  else if(pt<1950.0)  scale=7.06658775995;
  else if(pt<1960.0)  scale=6.8610479658;
  else if(pt<1970.0)  scale=6.89561588215;
  else if(pt<1980.0)  scale=6.60711411084;
  else if(pt<1990.0)  scale=6.43590851316;
  else if(pt<2000.0)  scale=6.34484573142;
  else if(pt<2010.0)  scale=6.19905945768;
  else if(pt<2020.0)  scale=6.02370572194;
  else if(pt<2030.0)  scale=5.83510527345;
  else if(pt<2040.0)  scale=5.7182865239;
  else if(pt<2050.0)  scale=5.53240442633;
  else if(pt<2060.0)  scale=5.33776433203;
  else if(pt<2070.0)  scale=5.19201238051;
  else if(pt<2080.0)  scale=5.15210848976;
  else if(pt<2090.0)  scale=4.89144362805;
  else if(pt<2100.0)  scale=4.7779579895;
  else if(pt<2110.0)  scale=4.6696188733;
  else if(pt<2120.0)  scale=4.47114505413;
  else if(pt<2130.0)  scale=4.3662455783;
  else if(pt<2140.0)  scale=4.15827673504;
  else if(pt<2150.0)  scale=4.09439295498;
  else if(pt<2160.0)  scale=3.91085447212;
  else if(pt<2170.0)  scale=3.83987694562;
  else if(pt<2180.0)  scale=3.71638482353;
  else if(pt<2190.0)  scale=3.61008563903;
  else if(pt<2200.0)  scale=3.48068958764;
  else if(pt<2210.0)  scale=3.34587244949;
  else if(pt<2220.0)  scale=3.24345365046;
  else if(pt<2230.0)  scale=3.11208377967;
  else if(pt<2240.0)  scale=3.02099390887;
  else if(pt<2250.0)  scale=2.93436364465;
  else if(pt<2260.0)  scale=2.81226596919;
  else if(pt<2270.0)  scale=2.71920088997;
  else if(pt<2280.0)  scale=2.61325162549;
  else if(pt<2290.0)  scale=2.52283155477;
  else if(pt<2300.0)  scale=2.43506992986;
  else if(pt<2310.0)  scale=2.33917411912;
  else if(pt<2320.0)  scale=2.26736154111;
  else if(pt<2330.0)  scale=2.1924853974;
  else if(pt<2340.0)  scale=2.09779465448;
  else if(pt<2350.0)  scale=2.02645194146;
  else if(pt<2360.0)  scale=1.94878545389;
  else if(pt<2370.0)  scale=1.87115944692;
  else if(pt<2380.0)  scale=1.80034345701;
  else if(pt<2390.0)  scale=1.73347932825;
  else if(pt<2400.0)  scale=1.66644349449;
  else if(pt<2410.0)  scale=1.61146361094;
  else if(pt<2420.0)  scale=1.56324365505;
  else if(pt<2430.0)  scale=1.49679959193;
  else if(pt<2440.0)  scale=1.44345521784;
  else if(pt<2450.0)  scale=1.39422599776;
  else if(pt<2460.0)  scale=1.34533105551;
  else if(pt<2470.0)  scale=1.29683728327;
  else if(pt<2480.0)  scale=1.26417087355;
  else if(pt<2490.0)  scale=1.21206511274;
  else if(pt<2500.0)  scale=1.18665729726;
  return scale;
}


float GetWeight_training_FlatTruthPt_SigToBkg_Pt_bkg_top(float pt){
  float scale=0;
  if(pt<0)  scale=0;
  else if(pt<210.0)  scale=0.889954233667;
  else if(pt<220.0)  scale=0.837322968058;
  else if(pt<230.0)  scale=0.795931028758;
  else if(pt<240.0)  scale=0.755671708782;
  else if(pt<250.0)  scale=0.728373237637;
  else if(pt<260.0)  scale=0.704978500881;
  else if(pt<270.0)  scale=0.670550123291;
  else if(pt<280.0)  scale=0.654730107996;
  else if(pt<290.0)  scale=0.630923881758;
  else if(pt<300.0)  scale=0.611153943502;
  else if(pt<310.0)  scale=0.592834119402;
  else if(pt<320.0)  scale=0.576449767104;
  else if(pt<330.0)  scale=0.559257756725;
  else if(pt<340.0)  scale=0.542704669717;
  else if(pt<350.0)  scale=0.531098174909;
  else if(pt<360.0)  scale=0.520297097696;
  else if(pt<370.0)  scale=0.51002363749;
  else if(pt<380.0)  scale=0.506354011476;
  else if(pt<390.0)  scale=0.50433736679;
  else if(pt<400.0)  scale=0.505334925079;
  else if(pt<410.0)  scale=0.579878510706;
  else if(pt<420.0)  scale=0.754642512806;
  else if(pt<430.0)  scale=0.827576662893;
  else if(pt<440.0)  scale=0.847657033056;
  else if(pt<450.0)  scale=0.846302249729;
  else if(pt<460.0)  scale=0.837867877471;
  else if(pt<470.0)  scale=0.828579283337;
  else if(pt<480.0)  scale=0.813398106249;
  else if(pt<490.0)  scale=0.794082893685;
  else if(pt<500.0)  scale=0.775998313352;
  else if(pt<510.0)  scale=0.757035209265;
  else if(pt<520.0)  scale=0.738374291803;
  else if(pt<530.0)  scale=0.715690338912;
  else if(pt<540.0)  scale=0.698692061601;
  else if(pt<550.0)  scale=0.682695380982;
  else if(pt<560.0)  scale=0.66652727931;
  else if(pt<570.0)  scale=0.65071362117;
  else if(pt<580.0)  scale=0.631706922961;
  else if(pt<590.0)  scale=0.615577284747;
  else if(pt<600.0)  scale=0.60176640788;
  else if(pt<610.0)  scale=0.586566257049;
  else if(pt<620.0)  scale=0.573571925437;
  else if(pt<630.0)  scale=0.558874531642;
  else if(pt<640.0)  scale=0.547312060808;
  else if(pt<650.0)  scale=0.534563772179;
  else if(pt<660.0)  scale=0.522599584853;
  else if(pt<670.0)  scale=0.511505673038;
  else if(pt<680.0)  scale=0.499127221006;
  else if(pt<690.0)  scale=0.49006353038;
  else if(pt<700.0)  scale=0.482435376587;
  else if(pt<710.0)  scale=0.4736053668;
  else if(pt<720.0)  scale=0.466093115639;
  else if(pt<730.0)  scale=0.45856551296;
  else if(pt<740.0)  scale=0.456385378854;
  else if(pt<750.0)  scale=0.447981215845;
  else if(pt<760.0)  scale=0.444355273186;
  else if(pt<770.0)  scale=0.441372738822;
  else if(pt<780.0)  scale=0.442822396213;
  else if(pt<790.0)  scale=0.441980315094;
  else if(pt<800.0)  scale=0.452454235807;
  else if(pt<810.0)  scale=0.542514081082;
  else if(pt<820.0)  scale=0.746339194191;
  else if(pt<830.0)  scale=0.834624834446;
  else if(pt<840.0)  scale=0.871052466333;
  else if(pt<850.0)  scale=0.883892262282;
  else if(pt<860.0)  scale=0.883969584909;
  else if(pt<870.0)  scale=0.883880296894;
  else if(pt<880.0)  scale=0.874585374854;
  else if(pt<890.0)  scale=0.862760246278;
  else if(pt<900.0)  scale=0.853469025887;
  else if(pt<910.0)  scale=0.844924569498;
  else if(pt<920.0)  scale=0.826566148376;
  else if(pt<930.0)  scale=0.809083249517;
  else if(pt<940.0)  scale=0.795405607409;
  else if(pt<950.0)  scale=0.78120086748;
  else if(pt<960.0)  scale=0.767064303328;
  else if(pt<970.0)  scale=0.752010723198;
  else if(pt<980.0)  scale=0.734997886852;
  else if(pt<990.0)  scale=0.721046461237;
  else if(pt<1000.0)  scale=0.709196933887;
  else if(pt<1010.0)  scale=0.692118904335;
  else if(pt<1020.0)  scale=0.680255236623;
  else if(pt<1030.0)  scale=0.668141511639;
  else if(pt<1040.0)  scale=0.652323348019;
  else if(pt<1050.0)  scale=0.641987694896;
  else if(pt<1060.0)  scale=0.629243023288;
  else if(pt<1070.0)  scale=0.614428084682;
  else if(pt<1080.0)  scale=0.602412351772;
  else if(pt<1090.0)  scale=0.58991797317;
  else if(pt<1100.0)  scale=0.579809407974;
  else if(pt<1110.0)  scale=0.570103288822;
  else if(pt<1120.0)  scale=0.55951031347;
  else if(pt<1130.0)  scale=0.553004927537;
  else if(pt<1140.0)  scale=0.538145479971;
  else if(pt<1150.0)  scale=0.5285607712;
  else if(pt<1160.0)  scale=0.517969865294;
  else if(pt<1170.0)  scale=0.512158015061;
  else if(pt<1180.0)  scale=0.502102404232;
  else if(pt<1190.0)  scale=0.496633648807;
  else if(pt<1200.0)  scale=0.492048470088;
  else if(pt<1210.0)  scale=0.483627549802;
  else if(pt<1220.0)  scale=0.479425302141;
  else if(pt<1230.0)  scale=0.472319254406;
  else if(pt<1240.0)  scale=0.470240631288;
  else if(pt<1250.0)  scale=0.467663336873;
  else if(pt<1260.0)  scale=0.466744154683;
  else if(pt<1270.0)  scale=0.46602527848;
  else if(pt<1280.0)  scale=0.471840686704;
  else if(pt<1290.0)  scale=0.481962619336;
  else if(pt<1300.0)  scale=0.501477350212;
  else if(pt<1310.0)  scale=0.697841807933;
  else if(pt<1320.0)  scale=1.34771365823;
  else if(pt<1330.0)  scale=1.84965370343;
  else if(pt<1340.0)  scale=2.1738820653;
  else if(pt<1350.0)  scale=2.41272634474;
  else if(pt<1360.0)  scale=2.57990738831;
  else if(pt<1370.0)  scale=2.69440407253;
  else if(pt<1380.0)  scale=2.78958835472;
  else if(pt<1390.0)  scale=2.85645638763;
  else if(pt<1400.0)  scale=2.88703920126;
  else if(pt<1410.0)  scale=2.9325563213;
  else if(pt<1420.0)  scale=2.90646419205;
  else if(pt<1430.0)  scale=2.90691460046;
  else if(pt<1440.0)  scale=2.88064295743;
  else if(pt<1450.0)  scale=2.8710699944;
  else if(pt<1460.0)  scale=2.83861201998;
  else if(pt<1470.0)  scale=2.78982528227;
  else if(pt<1480.0)  scale=2.74929071024;
  else if(pt<1490.0)  scale=2.69302270157;
  else if(pt<1500.0)  scale=2.6809274383;
  else if(pt<1510.0)  scale=2.60472606551;
  else if(pt<1520.0)  scale=2.57601053539;
  else if(pt<1530.0)  scale=2.52261684685;
  else if(pt<1540.0)  scale=2.47139162366;
  else if(pt<1550.0)  scale=2.41992904213;
  else if(pt<1560.0)  scale=2.37300757203;
  else if(pt<1570.0)  scale=2.32836653335;
  else if(pt<1580.0)  scale=2.31262104237;
  else if(pt<1590.0)  scale=2.22041641133;
  else if(pt<1600.0)  scale=2.19129393566;
  else if(pt<1610.0)  scale=2.15049316641;
  else if(pt<1620.0)  scale=2.09478318685;
  else if(pt<1630.0)  scale=2.07535044359;
  else if(pt<1640.0)  scale=2.02320033311;
  else if(pt<1650.0)  scale=1.97613150655;
  else if(pt<1660.0)  scale=1.9325102163;
  else if(pt<1670.0)  scale=1.90769312715;
  else if(pt<1680.0)  scale=1.88137356385;
  else if(pt<1690.0)  scale=1.83954875949;
  else if(pt<1700.0)  scale=1.80766835337;
  else if(pt<1710.0)  scale=1.77865493139;
  else if(pt<1720.0)  scale=1.74701835226;
  else if(pt<1730.0)  scale=1.72891678453;
  else if(pt<1740.0)  scale=1.70935992246;
  else if(pt<1750.0)  scale=1.6990319068;
  else if(pt<1760.0)  scale=1.68335066544;
  else if(pt<1770.0)  scale=1.68850207233;
  else if(pt<1780.0)  scale=1.68811131187;
  else if(pt<1790.0)  scale=1.71541120789;
  else if(pt<1800.0)  scale=1.77634525294;
  else if(pt<1810.0)  scale=2.48368485413;
  else if(pt<1820.0)  scale=4.47564399791;
  else if(pt<1830.0)  scale=5.79088351121;
  else if(pt<1840.0)  scale=6.51291315001;
  else if(pt<1850.0)  scale=7.05565601504;
  else if(pt<1860.0)  scale=7.30285142898;
  else if(pt<1870.0)  scale=7.40455998343;
  else if(pt<1880.0)  scale=7.48944148939;
  else if(pt<1890.0)  scale=7.61627859924;
  else if(pt<1900.0)  scale=7.57672890462;
  else if(pt<1910.0)  scale=7.56625195157;
  else if(pt<1920.0)  scale=7.44021917407;
  else if(pt<1930.0)  scale=7.35685575149;
  else if(pt<1940.0)  scale=7.14238360076;
  else if(pt<1950.0)  scale=7.07428032537;
  else if(pt<1960.0)  scale=6.86747587548;
  else if(pt<1970.0)  scale=6.9028524897;
  else if(pt<1980.0)  scale=6.61627720259;
  else if(pt<1990.0)  scale=6.4454634247;
  else if(pt<2000.0)  scale=6.35377740417;
  else if(pt<2010.0)  scale=6.20545627675;
  else if(pt<2020.0)  scale=6.03353390772;
  else if(pt<2030.0)  scale=5.84319062405;
  else if(pt<2040.0)  scale=5.7259905875;
  else if(pt<2050.0)  scale=5.54022149652;
  else if(pt<2060.0)  scale=5.34624729637;
  else if(pt<2070.0)  scale=5.20140500162;
  else if(pt<2080.0)  scale=5.15991636162;
  else if(pt<2090.0)  scale=4.90072642526;
  else if(pt<2100.0)  scale=4.78466338278;
  else if(pt<2110.0)  scale=4.67680015492;
  else if(pt<2120.0)  scale=4.47854404813;
  else if(pt<2130.0)  scale=4.37324741895;
  else if(pt<2140.0)  scale=4.16518245975;
  else if(pt<2150.0)  scale=4.10246373879;
  else if(pt<2160.0)  scale=3.91789088667;
  else if(pt<2170.0)  scale=3.84684864722;
  else if(pt<2180.0)  scale=3.72285184081;
  else if(pt<2190.0)  scale=3.6163323062;
  else if(pt<2200.0)  scale=3.48661492423;
  else if(pt<2210.0)  scale=3.35213449921;
  else if(pt<2220.0)  scale=3.24848150278;
  else if(pt<2230.0)  scale=3.11819997338;
  else if(pt<2240.0)  scale=3.02573369185;
  else if(pt<2250.0)  scale=2.94063345842;
  else if(pt<2260.0)  scale=2.81772053995;
  else if(pt<2270.0)  scale=2.72385701547;
  else if(pt<2280.0)  scale=2.61828076396;
  else if(pt<2290.0)  scale=2.52761810654;
  else if(pt<2300.0)  scale=2.44057218778;
  else if(pt<2310.0)  scale=2.34411866505;
  else if(pt<2320.0)  scale=2.27177356684;
  else if(pt<2330.0)  scale=2.19675579304;
  else if(pt<2340.0)  scale=2.10357488793;
  else if(pt<2350.0)  scale=2.03092901756;
  else if(pt<2360.0)  scale=1.95361226568;
  else if(pt<2370.0)  scale=1.87546220277;
  else if(pt<2380.0)  scale=1.80414173692;
  else if(pt<2390.0)  scale=1.73742596284;
  else if(pt<2400.0)  scale=1.67069367045;
  else if(pt<2410.0)  scale=1.61499237528;
  else if(pt<2420.0)  scale=1.56663291456;
  else if(pt<2430.0)  scale=1.50030123309;
  else if(pt<2440.0)  scale=1.44679584728;
  else if(pt<2450.0)  scale=1.39745105005;
  else if(pt<2460.0)  scale=1.34920913455;
  else if(pt<2470.0)  scale=1.30046716497;
  else if(pt<2480.0)  scale=1.2675540368;
  else if(pt<2490.0)  scale=1.21513715147;
  else if(pt<2500.0)  scale=1.19003051727;

  return scale;
}

